#line 1 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
/* -*- c -*- */

#include "global.h"
#include "interpret.h"
#include "svalue.h"
#include "opcodes.h"
#include "pike_macros.h"
#include "object.h"
#include "program.h"
#include "array.h"
#include "pike_error.h"
#include "constants.h"
#include "mapping.h"
#include "stralloc.h"
#include "multiset.h"
#include "pike_types.h"
#include "pike_memory.h"
#include "threads.h"
#include <math.h>
#include <ctype.h>
#include "module_support.h"
#include "cyclic.h"
#include "bignum.h"
#include "main.h"
#include "operators.h"













#define f_column_defined
PMOD_EXPORT void f_column(INT32 args) {
#line 39 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct array * data;
#line 39 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct svalue * index;
#line 39 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(args != 2) wrong_number_of_args_error("column",args,2);
#line 39 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(Pike_sp[0-2].type != PIKE_T_ARRAY) SIMPLE_BAD_ARG_ERROR("column",1,"array");
#line 39 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
debug_malloc_pass(data=sp[0-2].u.array);
#line 39 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
index=sp+1-2; dmalloc_touch_svalue(sp+1-2);
#line 42 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
{
  INT32 e;
  struct array *a;

  DECLARE_CYCLIC();

  /* Optimization */
  if(data->refs == 1)
  {
    /* An array with one ref cannot possibly be cyclic */
    struct svalue sval;
    data->type_field = BIT_MIXED | BIT_UNFINISHED;
    for(e=0;e<data->size;e++)
    {
      index_no_free(&sval, ITEM(data)+e, index);
      free_svalue(ITEM(data)+e);
      ITEM(data)[e]=sval;
    }
    pop_stack();
    return;
  }

  if((a=(struct array *)BEGIN_CYCLIC(data,0)))
  {
    add_ref(a);
  }else{
    push_array(a=allocate_array(data->size));
    SET_CYCLIC_RET(a);

    for(e=0;e<a->size;e++)
      index_no_free(ITEM(a)+e, ITEM(data)+e, index);

    sp--;
  }
  END_CYCLIC();
  do { struct array * ret_=(a); pop_n_elems(2); push_array(ret_); return; }while(0);
#line 78 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
}






}
#define f_mkmultiset_defined
PMOD_EXPORT void f_mkmultiset(INT32 args) {
#line 85 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct array * a;
#line 85 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(args != 1) wrong_number_of_args_error("mkmultiset",args,1);
#line 85 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(Pike_sp[0-1].type != PIKE_T_ARRAY) SIMPLE_BAD_ARG_ERROR("mkmultiset",1,"array(mixed)");
#line 85 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
debug_malloc_pass(a=sp[0-1].u.array);
#line 88 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
{
  do { struct multiset * ret_=(mkmultiset(a)); pop_stack(); push_multiset(ret_); return; }while(0);
#line 90 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
}












}
#define f_trace_defined
PMOD_EXPORT void f_trace(INT32 args) {
#line 103 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
INT_TYPE t;
#line 103 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(args != 1) wrong_number_of_args_error("trace",args,1);
#line 103 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(Pike_sp[0-1].type != PIKE_T_INT) SIMPLE_BAD_ARG_ERROR("trace",1,"int");
t=Pike_sp[0-1].u.integer;
#line 106 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
{
  pop_n_elems(args);
  push_int(t_flag);
  t_flag=t;
}







}
#define f_ctime_defined
PMOD_EXPORT void f_ctime(INT32 args) {
#line 118 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
INT_TYPE timestamp;
#line 118 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(args != 1) wrong_number_of_args_error("ctime",args,1);
#line 118 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(Pike_sp[0-1].type != PIKE_T_INT) SIMPLE_BAD_ARG_ERROR("ctime",1,"int");
timestamp=Pike_sp[0-1].u.integer;
#line 121 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
{
  time_t i=(time_t)timestamp;
  do { struct pike_string * ret_=(make_shared_string(ctime(&i))); pop_stack(); push_string(ret_); return; }while(0);
#line 124 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
}












}
#define f_mkmapping_defined
PMOD_EXPORT void f_mkmapping(INT32 args) {
#line 137 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct array * ind;
#line 137 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct array * val;
#line 137 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(args != 2) wrong_number_of_args_error("mkmapping",args,2);
#line 137 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(Pike_sp[0-2].type != PIKE_T_ARRAY) SIMPLE_BAD_ARG_ERROR("mkmapping",1,"array(mixed)");
#line 137 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
debug_malloc_pass(ind=sp[0-2].u.array);
#line 137 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(Pike_sp[1-2].type != PIKE_T_ARRAY) SIMPLE_BAD_ARG_ERROR("mkmapping",2,"array(mixed)");
#line 137 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
debug_malloc_pass(val=sp[1-2].u.array);
#line 140 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
{
  if(ind->size != val->size)
    bad_arg_error("mkmapping", sp-args, args, 2, "array", sp+1-args,
		  "mkmapping called on arrays of different sizes (%d != %d)\n",
		  ind->size, val->size);

  do { struct mapping * ret_=(mkmapping(ind, val)); pop_n_elems(2); push_mapping(ret_); return; }while(0);
#line 147 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
}







}
#define f_string_count_defined
PMOD_EXPORT void f_string_count(INT32 args) {
#line 155 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct pike_string * haystack;
#line 155 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct pike_string * needle;
#line 155 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(args != 2) wrong_number_of_args_error("string_count",args,2);
#line 155 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(Pike_sp[0-2].type != PIKE_T_STRING) SIMPLE_BAD_ARG_ERROR("String.count",1,"string");
#line 155 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
debug_malloc_pass(haystack=sp[0-2].u.string);
#line 155 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(Pike_sp[1-2].type != PIKE_T_STRING) SIMPLE_BAD_ARG_ERROR("String.count",2,"string");
#line 155 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
debug_malloc_pass(needle=sp[1-2].u.string);
#line 158 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
{
   ptrdiff_t c = 0;
   ptrdiff_t i, j;

   switch (needle->len)
   {
     case 0:
       switch (haystack->len)
       {
	 case 0: c=1; break; /* "" appears one time in "" */
	 case 1: c=0; break; /* "" doesn't appear in "x" */
	 default: c=haystack->len-1; /* one time between each character */
       }
       break;
     case 1:
       /* maybe optimize? */
     default:
       for (i=0; i<haystack->len; i++)
       {
	 j=string_search(haystack,needle,i);
	 if (j==-1) break;
	 i=j+needle->len-1;
	 c++;
       }
       break;
   }
   do { INT_TYPE ret_=(DO_NOT_WARN((INT_TYPE)c)); pop_n_elems(2); push_int(ret_); return; }while(0);
#line 185 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
}



}
#define f_program_implements_defined
PMOD_EXPORT void f_program_implements(INT32 args) {
#line 189 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct program * prog;
#line 189 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct program * api;
#line 189 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(args != 2) wrong_number_of_args_error("program_implements",args,2);
#line 189 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(!( prog=program_from_svalue(sp+0-2))) SIMPLE_BAD_ARG_ERROR("Program.implements",1,"program");
#line 189 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(!( api=program_from_svalue(sp+1-2))) SIMPLE_BAD_ARG_ERROR("Program.implements",2,"program");
#line 192 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
{
  do { INT_TYPE ret_=(implements(prog, api)); pop_n_elems(2); push_int(ret_); return; }while(0);
#line 194 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
}



}
#define f_program_inherits_defined
PMOD_EXPORT void f_program_inherits(INT32 args) {
#line 198 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct program * child;
#line 198 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct program * parent;
#line 198 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(args != 2) wrong_number_of_args_error("program_inherits",args,2);
#line 198 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(!( child=program_from_svalue(sp+0-2))) SIMPLE_BAD_ARG_ERROR("Program.inherits",1,"program");
#line 198 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(!( parent=program_from_svalue(sp+1-2))) SIMPLE_BAD_ARG_ERROR("Program.inherits",2,"program");
#line 201 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
{
  do { INT_TYPE ret_=(!!low_get_storage(parent, child)); pop_n_elems(2); push_int(ret_); return; }while(0);
#line 203 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
}









}
#define f_program_defined_defined
PMOD_EXPORT void f_program_defined(INT32 args) {
#line 213 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct program * p;
#line 213 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(args != 1) wrong_number_of_args_error("program_defined",args,1);
#line 213 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(!( p=program_from_svalue(sp+0-1))) SIMPLE_BAD_ARG_ERROR("Program.defined",1,"program");
#line 216 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
{
  if(p && p->num_linenumbers)
  {
    char *tmp;
    INT32 line;
    if((tmp=get_line(p->program, p, &line)))
    {
      struct pike_string *tmp2;
      tmp2=make_shared_string(tmp);
      pop_n_elems(args);

      push_string(tmp2);
      if(line > 1)
      {
	push_constant_text(":");
	push_int(line);
	f_add(3);
      }
      return;
    }
  }

  pop_n_elems(args);
  push_int(0);
}













}
#define f_string_width_defined
PMOD_EXPORT void f_string_width(INT32 args) {
#line 254 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct pike_string * s;
#line 254 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(args != 1) wrong_number_of_args_error("string_width",args,1);
#line 254 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(Pike_sp[0-1].type != PIKE_T_STRING) SIMPLE_BAD_ARG_ERROR("String.width",1,"string");
#line 254 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
debug_malloc_pass(s=sp[0-1].u.string);
#line 257 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
{
  do { INT_TYPE ret_=(8 * (1 << s->size_shift)); pop_stack(); push_int(ret_); return; }while(0);
#line 259 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
}














}
#define f_m_delete_defined
PMOD_EXPORT void f_m_delete(INT32 args) {
#line 274 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct svalue * map;
#line 274 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct svalue * index;
#line 274 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(args != 2) wrong_number_of_args_error("m_delete",args,2);
#line 274 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
map=sp+0-2; dmalloc_touch_svalue(sp+0-2);
#line 274 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
index=sp+1-2; dmalloc_touch_svalue(sp+1-2);
#line 277 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
{
  /*FIXME: Should be
   *     type function(mapping(1=mixed:2=mixed),1:2)|
   *     function(object,mixed:mixed);
   *
   *     or similar
   */
  if( map->type == T_MAPPING )
  {
    struct svalue s;
    map_delete_no_free(map->u.mapping, index, &s);
    pop_n_elems(args);
    *sp=s;
    sp++;
  }
  else
  {
    apply_lfun( map->u.object, LFUN__M_DELETE, 1 );
    stack_swap();
    pop_stack();
  }
}



}
#define f_get_weak_flag_defined
PMOD_EXPORT void f_get_weak_flag(INT32 args) {
#line 302 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
struct svalue * m;
#line 302 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
if(args != 1) wrong_number_of_args_error("get_weak_flag",args,1);
#line 302 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
m=sp+0-1; dmalloc_touch_svalue(sp+0-1);
#line 305 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
{
  int flag = 0;
  switch (m->type) {
    case T_ARRAY:
      flag = !!(m->u.array->flags & ARRAY_WEAK_FLAG);
      break;
    case T_MAPPING:
      flag = !!(mapping_get_flags(m->u.mapping) & MAPPING_FLAG_WEAK);
      break;
    case T_MULTISET:
      flag = !!(m->u.multiset->ind->flags & (ARRAY_WEAK_FLAG|ARRAY_WEAK_SHRINK));
      break;
    default:
      SIMPLE_BAD_ARG_ERROR("get_weak_flag",1,"array|mapping|multiset");
  }
  pop_n_elems(args);
  push_int(flag);
}

}
#line 324 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
void init_builtin(void)
{

#ifdef f_column_defined
#line 39 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
  ADD_EFUN("column", f_column, tFunc(tArray tMix, tArray), OPT_TRY_OPTIMIZE);
#endif

#ifdef f_mkmultiset_defined
#line 85 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
  ADD_EFUN("mkmultiset", f_mkmultiset, tFunc(tArr(tSetvar(1,tMix)), tSet(tVar(1))), OPT_TRY_OPTIMIZE|OPT_EXTERNAL_DEPEND);
#endif

#ifdef f_trace_defined
#line 103 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
  ADD_EFUN("trace", f_trace, tFunc(tInt, tInt), OPT_SIDE_EFFECT);
#endif

#ifdef f_ctime_defined
#line 118 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
  ADD_EFUN("ctime", f_ctime, tFunc(tInt, tStr), OPT_TRY_OPTIMIZE);
#endif

#ifdef f_mkmapping_defined
#line 137 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
  ADD_EFUN("mkmapping", f_mkmapping, tFunc(tArr(tSetvar(1,tMix)) tArr(tSetvar(2,tMix)), tMap(tVar(1),tVar(2))), OPT_TRY_OPTIMIZE|OPT_EXTERNAL_DEPEND);
#endif

#ifdef f_string_count_defined
#line 155 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
  ADD_FUNCTION2("string_count", f_string_count, tFunc(tStr tStr, tInt), 0, OPT_TRY_OPTIMIZE);
#endif

#ifdef f_program_implements_defined
#line 189 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
  ADD_FUNCTION2("program_implements", f_program_implements, tFunc(tProgram tProgram, tInt), 0, OPT_TRY_OPTIMIZE);
#endif

#ifdef f_program_inherits_defined
#line 198 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
  ADD_FUNCTION2("program_inherits", f_program_inherits, tFunc(tProgram tProgram, tInt), 0, OPT_TRY_OPTIMIZE);
#endif

#ifdef f_program_defined_defined
#line 213 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
  ADD_FUNCTION2("program_defined", f_program_defined, tFunc(tProgram, tStr), 0, OPT_TRY_OPTIMIZE);
#endif

#ifdef f_string_width_defined
#line 254 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
  ADD_FUNCTION2("string_width", f_string_width, tFunc(tStr, tInt), 0, OPT_TRY_OPTIMIZE);
#endif

#ifdef f_m_delete_defined
#line 274 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
  ADD_EFUN("m_delete", f_m_delete, tFunc(tOr(tObj,tMapping) tMix, tMix), OPT_SIDE_EFFECT);
#endif

#ifdef f_get_weak_flag_defined
#line 302 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
  ADD_EFUN("get_weak_flag", f_get_weak_flag, tFunc(tOr(tArray,tOr(tMapping,tMultiset)), "\b\0\0\0\0\0\0\0\1"), OPT_EXTERNAL_DEPEND);
#endif
#line 327 "/home/grubba/src/Pike/7.2/src/builtin.cmod"
}

